## runc-app 1.2.5

=== Makefile ===
SHELL = /bin/bash

CONTAINER_ENGINE := docker
GO ?= go

PREFIX ?= /usr/local
BINDIR := $(PREFIX)/sbin
MANDIR := $(PREFIX)/share/man

GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
GIT_BRANCH_CLEAN := $(shell echo $(GIT_BRANCH) | sed -e "s/[^[:alnum:]]/-/g")
RUNC_IMAGE := runc_dev$(if $(GIT_BRANCH_CLEAN),:$(GIT_BRANCH_CLEAN))
PROJECT := github.com/opencontainers/runc
EXTRA_BUILDTAGS :=
BUILDTAGS := seccomp urfave_cli_no_docs
BUILDTAGS += $(EXTRA_BUILDTAGS)

COMMIT := $(shell git describe --dirty --long --always)
EXTRA_VERSION :=
VERSION := $(shell cat ./VERSION)$(EXTRA_VERSION)
LDFLAGS_COMMON := -X main.gitCommit=$(COMMIT) -X main.version=$(VERSION)

GOARCH := $(shell $(GO) env GOARCH)

# -trimpath may be required on some platforms to create reproducible builds
# on the other hand, it does strip out build information, like -ldflags, which
# some tools use to infer the version, in the absence of go information,
# which happens when you use `go build`.
# This enables someone to override by doing `make runc TRIMPATH= ` etc.
TRIMPATH := -trimpath

GO_BUILDMODE :=
# Enable dynamic PIE executables on supported platforms.
ifneq (,$(filter $(GOARCH),386 amd64 arm arm64 ppc64le riscv64 s390x))
	ifeq (,$(findstring -race,$(EXTRA_FLAGS)))
		GO_BUILDMODE := "-buildmode=pie"
	endif
endif
GO_BUILD := $(GO) build $(TRIMPATH) $(GO_BUILDMODE) \
	$(EXTRA_FLAGS) -tags "$(BUILDTAGS)" \
	-ldflags "$(LDFLAGS_COMMON) $(EXTRA_LDFLAGS)"

GO_BUILDMODE_STATIC :=
LDFLAGS_STATIC := -extldflags -static
# Enable static PIE executables on supported platforms.
# This (among the other things) requires libc support (rcrt1.o), which seems
# to be available only for arm64 and amd64 (Debian Bullseye).
ifneq (,$(filter $(GOARCH),arm64 amd64))
	ifeq (,$(findstring -race,$(EXTRA_FLAGS)))
		GO_BUILDMODE_STATIC := -buildmode=pie
		LDFLAGS_STATIC := -linkmode external -extldflags -static-pie
	endif
endif
# Enable static PIE binaries on supported platforms.
GO_BUILD_STATIC := $(GO) build $(TRIMPATH) $(GO_BUILDMODE_STATIC) \
	$(EXTRA_FLAGS) -tags "$(BUILDTAGS) netgo osusergo" \
	-ldflags "$(LDFLAGS_COMMON) $(LDFLAGS_STATIC) $(EXTRA_LDFLAGS)"

GPG_KEYID ?= asarai@suse.de

# Some targets need cgo, which is disabled by default when cross compiling.
# Enable cgo explicitly for those.
# Both runc and libcontainer/integration need libcontainer/nsenter.
runc static localunittest: export CGO_ENABLED=1
# seccompagent needs libseccomp (when seccomp build tag is set).
ifneq (,$(filter $(BUILDTAGS),seccomp))
seccompagent: export CGO_ENABLED=1
endif

.DEFAULT: runc

.PHONY: runc
runc: runc-bin

.PHONY: runc-bin
runc-bin:
	$(GO_BUILD) -o runc .

.PHONY: all
all: runc memfd-bind recvtty sd-helper seccompagent fs-idmap pidfd-kill remap-rootfs

.PHONY: memfd-bind
memfd-bind:
	$(GO_BUILD) -o contrib/cmd/$@/$@ ./contrib/cmd/$@

.PHONY: recvtty sd-helper seccompagent fs-idmap pidfd-kill remap-rootfs
recvtty sd-helper seccompagent fs-idmap pidfd-kill remap-rootfs:
	$(GO_BUILD) -o tests/cmd/$@/$@ ./tests/cmd/$@

.PHONY: clean
clean:
	rm -f runc runc-*
	rm -f contrib/cmd/memfd-bind/memfd-bind
	rm -f tests/cmd/recvtty/recvtty
	rm -f tests/cmd/sd-helper/sd-helper
	rm -f tests/cmd/seccompagent/seccompagent
	rm -f tests/cmd/fs-idmap/fs-idmap
	rm -f tests/cmd/pidfd-kill/pidfd-kill
	rm -f tests/cmd/remap-rootfs/remap-rootfs
	sudo rm -rf release
	rm -rf man/man8

.PHONY: static
static: static-bin

.PHONY: static-bin
static-bin:
	$(GO_BUILD_STATIC) -o runc .

.PHONY: releaseall
releaseall: RELEASE_ARGS := "-a 386 -a amd64 -a arm64 -a armel -a armhf -a ppc64le -a riscv64 -a s390x"
releaseall: release

.PHONY: release
release: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		--rm -v $(CURDIR):/go/src/$(PROJECT) \
		-e RELEASE_ARGS=$(RELEASE_ARGS) \
		$(RUNC_IMAGE) make localrelease
	script/release_sign.sh -S $(GPG_KEYID) -r release/$(VERSION) -v $(VERSION)

.PHONY: localrelease
localrelease: verify-changelog
	script/release_build.sh -r release/$(VERSION) -v $(VERSION) $(RELEASE_ARGS)

.PHONY: dbuild
dbuild: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		--privileged --rm \
		-v $(CURDIR):/go/src/$(PROJECT) \
		$(RUNC_IMAGE) make clean all

.PHONY: lint
lint:
	golangci-lint run ./...

.PHONY: man
man:
	man/md2man-all.sh

.PHONY: runcimage
runcimage:
	$(CONTAINER_ENGINE) build $(CONTAINER_ENGINE_BUILD_FLAGS) -t $(RUNC_IMAGE) .

.PHONY: test
test: unittest integration rootlessintegration

.PHONY: localtest
localtest: localunittest localintegration localrootlessintegration

.PHONY: unittest
unittest: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		-t --privileged --rm \
		-v /lib/modules:/lib/modules:ro \
		-v $(CURDIR):/go/src/$(PROJECT) \
		$(RUNC_IMAGE) make localunittest TESTFLAGS="$(TESTFLAGS)"

.PHONY: localunittest
localunittest: all
	$(GO) test -timeout 3m -tags "$(BUILDTAGS)" $(TESTFLAGS) -v ./...

.PHONY: integration
integration: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		-t --privileged --rm \
		-v /lib/modules:/lib/modules:ro \
		-v $(CURDIR):/go/src/$(PROJECT) \
		$(RUNC_IMAGE) make localintegration TESTPATH="$(TESTPATH)"

.PHONY: localintegration
localintegration: all
	bats -t tests/integration$(TESTPATH)

.PHONY: rootlessintegration
rootlessintegration: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		-t --privileged --rm \
		-v $(CURDIR):/go/src/$(PROJECT) \
		-e ROOTLESS_TESTPATH \
		$(RUNC_IMAGE) make localrootlessintegration

.PHONY: localrootlessintegration
localrootlessintegration: all
	tests/rootless.sh

.PHONY: shell
shell: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		-ti --privileged --rm \
		-v $(CURDIR):/go/src/$(PROJECT) \
		$(RUNC_IMAGE) bash

.PHONY: install
install:
	install -D -m0755 runc $(DESTDIR)$(BINDIR)/runc

.PHONY: install-bash
install-bash:
	install -D -m0644 contrib/completions/bash/runc $(DESTDIR)$(PREFIX)/share/bash-completion/completions/runc

.PHONY: install-man
install-man: man
	install -d -m 755 $(DESTDIR)$(MANDIR)/man8
	install -D -m 644 man/man8/*.8 $(DESTDIR)$(MANDIR)/man8

.PHONY: cfmt
cfmt: C_SRC=$(shell git ls-files '*.c' | grep -v '^vendor/')
cfmt:
	indent -linux -l120 -il0 -ppi2 -cp1 -T size_t -T jmp_buf $(C_SRC)

.PHONY: shellcheck
shellcheck:
	shellcheck tests/integration/*.bats tests/integration/*.sh \
		tests/integration/*.bash tests/*.sh \
		man/*.sh script/*
	# TODO: add shellcheck for more sh files (contrib/completions/bash/runc).

.PHONY: shfmt
shfmt:
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		--rm -v $(CURDIR):/src -w /src \
		mvdan/shfmt:v3.5.1 -d -w .

.PHONY: localshfmt
localshfmt:
	shfmt -d -w .

.PHONY: vendor
vendor:
	$(GO) mod tidy
	$(GO) mod vendor
	$(GO) mod verify

.PHONY: verify-changelog
verify-changelog:
	# No space at EOL.
	! grep -n '\s$$' CHANGELOG.md
	# Period before issue/PR references.
	! grep -n '[0-9a-zA-Z][^.] (#[1-9][0-9, #]*)$$' CHANGELOG.md

.PHONY: verify-dependencies
verify-dependencies: vendor
	@test -z "$$(git status --porcelain -- go.mod go.sum vendor/)" \
		|| (echo -e "git status:\n $$(git status -- go.mod go.sum vendor/)\nerror: vendor/, go.mod and/or go.sum not up to date. Run \"make vendor\" to update"; exit 1) \
		&& echo "all vendor files are up to date."

.PHONY: validate-keyring
validate-keyring:
	script/keyring_validate.sh

## runc-app 1.1.12

=== debian/changelog ===
runc-app (1.1.12-0ubuntu3) noble; urgency=medium

  * Build with Go 1.22.
    - d/control: b-d on golang-1.22-go instead of golang-1.21-go
    - d/rules: add Go 1.22 to $PATH

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 17 Apr 2024 16:52:45 -0300

runc-app (1.1.12-0ubuntu2) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:18:47 +0200

runc-app (1.1.12-0ubuntu1) noble; urgency=medium

  * New upstream release (LP: #2051918).

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 19 Feb 2024 18:31:43 -0300

runc-app (1.1.10-0ubuntu1) noble; urgency=medium

  * Initial release. See LP #2022390.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 13 Dec 2023 14:05:31 -0300

=== debian/control ===
Source: runc-app
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               dh-golang,
               go-md2man,
               golang-1.22-go,
               libapparmor-dev,
               libseccomp-dev,
               pkg-config,
               protobuf-compiler
Standards-Version: 4.6.2
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://github.com/canonical/runc-app.git
Vcs-Browser: https://github.com/canonical/runc-app

Package: runc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Open Container Project - runtime
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_GOPKG := github.com/opencontainers/runc
TAGS=apparmor seccomp selinux ambient
VERSION=$(shell dpkg-parsechangelog -SVersion)

# Build with Golang 1.22
export PATH := /usr/lib/go-1.22/bin:$(PATH)

export GO111MODULE := off
export GOCACHE := $(CURDIR)/.cache

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_configure:
	cd man && ./md2man-all.sh
	dh_auto_configure
	## Remove extra license files:
	$(RM) -v \
            _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/*/*/LICENSE* \
        ;

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "-X main.version=$(VERSION)"

override_dh_auto_test:
	DH_GOLANG_EXCLUDES="libcontainer/integration" \
        dh_auto_test -- -tags "$(TAGS)"

override_dh_auto_install:
	dh_auto_install
	# Do not ship the library code
	$(RM) -vrf debian/runc/usr/share/gocode

## runc-app 1.2.5

=== debian/changelog ===
runc-app (1.2.5-0ubuntu1~24.10.1) oracular; urgency=medium

  * Backport from plucky to oracular (LP: #2085187)
  * d/control: build with golang 1.22 for consistency across the supported
    release
  * d/rules: add golang 1.22 to PATH

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 01 Apr 2025 17:33:57 -0300

runc-app (1.2.5-0ubuntu1) plucky; urgency=medium

  [ Lucas Kanashiro ]
  * Do not install example/test utilities (LP: #2076981)

  [ Athos Ribeiro ]
  * d/gbp.conf: use default value for merging
  * d/control: build with golang 1.24 (LP: #2098665)
  * d/rules: add golang 1.24 to PATH
  * New upstream version 1.2.5
  * d/p/0002-skip-privileged-test-factory_linux_test.go.patch: refresh patch
  * d/p/0004-skip-test-cgroups_test.go.patch: refresh patch
  * d/p/0008-tests-enable-seccomp-default-action-tests-on-arm.patch: drop
    patch applied upstream
  * d/p/0010-export-blockIODevice.patch: drop patch applied upstream
  * d/copyright: update copyright data
  * d/rules: set GO111MODULE to auto

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 18 Feb 2025 10:30:11 -0300

runc-app (1.1.12-0ubuntu4) oracular-proposed; urgency=medium

  * LP: #2076340: No-change rebuild to pick up changed build flags on
    ppc64el and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 08 Aug 2024 14:55:51 +0200

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,8 @@
 # Build with Golang 1.22
 export PATH := /usr/lib/go-1.22/bin:$(PATH)
 
-export GO111MODULE := off
+# https://go.dev/blog/go116-module-changes
+export GO111MODULE := auto
 export GOCACHE := $(CURDIR)/.cache
 
 %:
@@ -35,3 +36,5 @@
 	dh_auto_install
 	# Do not ship the library code
 	$(RM) -vrf debian/runc/usr/share/gocode
+	# Do not ship example/test utilities (LP: #2076981)
+	$(foreach bin, recvtty sd-helper seccompagent, $(RM) -v debian/runc/usr/bin/$(bin))

## runc-app 1.3.0

=== debian/changelog ===
runc-app (1.3.0-0ubuntu2~24.04.1) noble; urgency=medium

  * Backport from questing to noble (LP: #2112523)
    - d/control: do not include adjustments for runc-stable present in
      questing since runc-stable is not available in noble
  * d/control: build with golang 1.23
  * d/rules: add golang 1.23 to PATH

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Thu, 11 Sep 2025 15:09:29 -0300

runc-app (1.3.0-0ubuntu2) questing; urgency=medium

  * d/control: adjust for new runc-stable package in the archive
    - Conflicts/Replaces runc
    - Update package description

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Fri, 29 Aug 2025 15:00:07 -0300

runc-app (1.3.0-0ubuntu1) questing; urgency=medium

  * New upstream version 1.3.0
  * d/patches: drop patches to cgroups tests. runc now uses
    opencontainers/cgroups:
    - d/p/0001-skip-test-hugetlb_test.go.patch
    - d/p/0004-skip-test-cgroups_test.go.patch
    - d/p/0006-skip-test-paths_test.go.patch
    - d/p/0007-skip-test-manager_test.go.patch
    - d/p/0009-skip-test-file_test.go.patch
  * d/copyright: update copyright data

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 01 Jul 2025 10:50:35 -0300

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
                go-md2man,
-               golang-1.22-go,
+               golang-1.23-go,
                libapparmor-dev,
                libseccomp-dev,
                pkg-config,

=== debian/rules ===
--- 
+++ 
@@ -7,8 +7,8 @@
 TAGS=apparmor seccomp selinux ambient
 VERSION=$(shell dpkg-parsechangelog -SVersion)
 
-# Build with Golang 1.22
-export PATH := /usr/lib/go-1.22/bin:$(PATH)
+# Build with Golang 1.23
+export PATH := /usr/lib/go-1.23/bin:$(PATH)
 
 # https://go.dev/blog/go116-module-changes
 export GO111MODULE := auto

=== debian/tests/control ===
Tests: basic-smoke
Depends: busybox-static, @
Restrictions: allow-stderr, isolation-machine, needs-root

Test-Command: /usr/bin/dh_golang_autopkgtest
Depends: @, @builddeps@, dh-golang
Restrictions: allow-stderr, isolation-machine, needs-root

## runc-app 1.3.3

=== vendor/github.com/checkpoint-restore/go-criu/v6/Makefile ===
SHELL = /bin/bash
GO ?= go
CC ?= gcc

all: build

lint:
	golangci-lint run ./...

build: rpc/rpc.pb.go stats/stats.pb.go
	$(GO) build -v ./...
	# Build crit binary
	$(MAKE) -C crit bin/crit

test: build
	$(MAKE) -C test

coverage:
	$(MAKE) -C test coverage

codecov:
	$(MAKE) -C test codecov

rpc/rpc.proto:
	curl -sSL https://raw.githubusercontent.com/checkpoint-restore/criu/master/images/rpc.proto -o $@

rpc/rpc.pb.go: rpc/rpc.proto
	protoc --go_out=. --go_opt=M$^=rpc/ $^

stats/stats.proto:
	curl -sSL https://raw.githubusercontent.com/checkpoint-restore/criu/master/images/stats.proto -o $@

stats/stats.pb.go: stats/stats.proto
	protoc --go_out=. --go_opt=M$^=stats/ $^

vendor:
	GO111MODULE=on $(GO) mod tidy
	GO111MODULE=on $(GO) mod vendor
	GO111MODULE=on $(GO) mod verify

.PHONY: build test lint vendor coverage codecov

=== debian/changelog ===
runc-app (1.3.3-0ubuntu1~25.10.2) questing-security; urgency=medium

  * d/patches: Bug fix when starting containers with mounts that contain "..":
    - d/p/v1.3-0025-openat2-improve-resilience-on-busy-systems.patch:
      openat2: improve resilience on busy systems

 -- Nick Galanis <nick.galanis@canonical.com>  Mon, 03 Nov 2025 16:01:20 +0100

runc-app (1.3.3-0ubuntu1~25.10.1)  questing-security; urgency=medium

  * New upstream release.
  * SECURITY UPDATE: Escaping a container via masked path abuse 
    - CVE-2025-31133
  * SECURITY UPDATE: Escaping a container due to wrong bind-mounts
    - CVE-2025-52565
  * SECURITY UPDATE: Escaping a container and denial of service
    due to arbitrary writes.
    - CVE-2025-52881

 -- Nick Galanis <nick.galanis@canonical.com>  Thu, 30 Oct 2025 11:49:02 +0000

=== debian/rules ===
--- 
+++ 
@@ -7,8 +7,8 @@
 TAGS=apparmor seccomp selinux ambient
 VERSION=$(shell dpkg-parsechangelog -SVersion)
 
-# Build with Golang 1.23
-export PATH := /usr/lib/go-1.23/bin:$(PATH)
+# Build with Golang 1.24
+export PATH := /usr/lib/go-1.24/bin:$(PATH)
 
 # https://go.dev/blog/go116-module-changes
 export GO111MODULE := auto

## runc-app 1.4.0

=== debian/changelog ===
runc-app (1.4.0-0ubuntu1) resolute; urgency=medium

  * New upstream version 1.4.0
  * d/copyright: update copyright data
  * d/patches: drop patches applied upstream
    - improve-resilience-on-busy-system.patch
    - lp-2130744.patch

 -- Athos Ribeiro <athos@ubuntu.com>  Tue, 13 Jan 2026 12:54:08 -0300

runc-app (1.3.3-0ubuntu2) resolute; urgency=medium

   * SECURITY REGRESSION: Wrong default tmpfs permission handling
     (LP: #2130744)
     - d/p/lp-2130744.patch: rootfs: only set mode= for tmpfs
       mount if target already existed

 -- Nick Galanis <nick.galanis@canonical.com>  Wed, 19 Nov 2025 12:58:14 +0000

runc-app (1.3.3-0ubuntu1) resolute; urgency=medium

  * Import Upstream version 1.3.3
  * d/p/improve-resilience-on-busy-system.patch: fix regression on starting
    containers mounting paths with ".."

 -- Athos Ribeiro <athos@ubuntu.com>  Wed, 12 Nov 2025 20:35:07 -0300
